#include "projet.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

extern GtkWidget *gl_window;

GtkWidget*
create_particle_window (void)
{
  GtkWidget *particle_window;
  GtkWidget *particlew_vbox1;
  GtkWidget *particlew_paramlbl;
  GtkWidget *particlew_hseparator1;
  GtkWidget *particlew_table1;
  GtkObject *particlew_numitersb_adj;
  GtkWidget *particlew_numitersb;
  GtkObject *particlew_numislandsb_adj;
  GtkWidget *particlew_numislandsb;
  GtkWidget *particlew_label2;
  GtkWidget *particlew_label6;
  GtkWidget *particlew_label8;
  GtkObject *particlew_dhsb_adj;
  GtkWidget *particlew_dhsb;
  GtkWidget *particlew_hseparator2;
  GtkWidget *particlew_hbuttonbox1;
  GtkWidget *particlew_okb;

  particle_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (particle_window), 3);
  gtk_window_set_transient_for(GTK_WINDOW (particle_window),GTK_WINDOW (gl_window));
  gtk_window_set_title (GTK_WINDOW (particle_window), _("Particle deposition"));

  particlew_vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (particlew_vbox1);
  gtk_container_add (GTK_CONTAINER (particle_window), particlew_vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (particlew_vbox1), 2);

  particlew_paramlbl = gtk_label_new (_("Parametres"));
  gtk_widget_show (particlew_paramlbl);
  gtk_box_pack_start (GTK_BOX (particlew_vbox1), particlew_paramlbl, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (particlew_paramlbl), GTK_JUSTIFY_LEFT);

  particlew_hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (particlew_hseparator1);
  gtk_box_pack_start (GTK_BOX (particlew_vbox1), particlew_hseparator1, TRUE, TRUE, 0);

  particlew_table1 = gtk_table_new (5, 2, FALSE);
  gtk_widget_show (particlew_table1);
  gtk_box_pack_start (GTK_BOX (particlew_vbox1), particlew_table1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (particlew_table1), 10);
  gtk_table_set_row_spacings (GTK_TABLE (particlew_table1), 3);
  gtk_table_set_col_spacings (GTK_TABLE (particlew_table1), 12);

  particlew_label2 = gtk_label_new (_("Nombre d'iterations"));
  gtk_widget_show (particlew_label2);
  gtk_table_attach (GTK_TABLE (particlew_table1), particlew_label2, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (particlew_label2), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (particlew_label2), 0, 0.5);
  
  particlew_numitersb_adj = gtk_adjustment_new (1000, 1, 5000, 1, 10, 10);
  particlew_numitersb = gtk_spin_button_new (GTK_ADJUSTMENT (particlew_numitersb_adj), 1, 0);
  gtk_widget_show (particlew_numitersb);
  gtk_table_attach (GTK_TABLE (particlew_table1), particlew_numitersb, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (particlew_numitersb), TRUE);

  particlew_label8 = gtk_label_new (_("Nombre d'iles"));
  gtk_widget_show (particlew_label8);
  gtk_table_attach (GTK_TABLE (particlew_table1), particlew_label8, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (particlew_label8), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (particlew_label8), 0, 0.5);

  particlew_numislandsb_adj = gtk_adjustment_new (10, 1, 500, 1, 10, 10);
  particlew_numislandsb = gtk_spin_button_new (GTK_ADJUSTMENT (particlew_numislandsb_adj), 1, 0);
  gtk_widget_show (particlew_numislandsb);
  gtk_table_attach (GTK_TABLE (particlew_table1), particlew_numislandsb, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (particlew_numislandsb), TRUE);

  particlew_label6 = gtk_label_new (_("dh"));
  gtk_widget_show (particlew_label6);
  gtk_table_attach (GTK_TABLE (particlew_table1), particlew_label6, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (particlew_label6), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (particlew_label6), 0, 0.5);

  particlew_dhsb_adj = gtk_adjustment_new (8.0, 1.0, 32.0, 0.1, 1, 1);
  particlew_dhsb = gtk_spin_button_new (GTK_ADJUSTMENT (particlew_dhsb_adj), 0.3, 2);
  gtk_widget_show (particlew_dhsb);
  gtk_table_attach (GTK_TABLE (particlew_table1), particlew_dhsb, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  particlew_hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (particlew_hseparator2);
  gtk_box_pack_start (GTK_BOX (particlew_vbox1), particlew_hseparator2, TRUE, TRUE, 0);

  particlew_hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (particlew_hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (particlew_vbox1), particlew_hbuttonbox1, TRUE, TRUE, 0);

  particlew_okb = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (particlew_okb);
  gtk_container_add (GTK_CONTAINER (particlew_hbuttonbox1), particlew_okb);
  GTK_WIDGET_SET_FLAGS (particlew_okb, GTK_CAN_DEFAULT);

          
  g_signal_connect ((gpointer) particlew_okb, "clicked",
                    G_CALLBACK (on_particlew_okb_clicked),
                    G_OBJECT (particle_window));
                    
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (particle_window, particle_window, "particle_window");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_vbox1, "particlew_vbox1");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_paramlbl, "particlew_paramlbl");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_hseparator1, "particlew_hseparator1");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_table1, "particlew_table1");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_numitersb, "particlew_numitersb");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_numislandsb, "particlew_numislandsb");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_label2, "particlew_label2");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_label6, "particlew_label6");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_dhsb, "particlew_dhsb");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_hseparator2, "particlew_hseparator2");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_hbuttonbox1, "particlew_hbuttonbox1");
  GLADE_HOOKUP_OBJECT (particle_window, particlew_okb, "particlew_okb");

  gtk_widget_grab_focus (particlew_okb);
  gtk_widget_grab_default (particlew_okb);
  return particle_window;
}
