#include "../projet.h"

#ifdef USE_SDL
TER_param_hyperb_t hyp_param;

void
sdl_display(void)
{
  gl_generic_render_scene();
   
  SDL_GL_SwapBuffers();
}

void fill_default_hyperb_params (TER_param_hyperb_t *params)
{
  params->num_iter = 50;
  params->radius_min = 10;
  params->radius_max = 30;
  params->power = 0.3333;
  params->factor = 50;
  params->epsilon = ALGO_HYPERB_CRATERS | ALGO_HYPERB_SPHERES;
}

void sdl_ui_handle_keypressed(SDL_keysym * keysym)
{
    switch(keysym -> sym)
    {
        case SDLK_ESCAPE: 
            SDL_Quit();
	    exit(0);
	    break;
	
	case SDLK_F1: 
            /* blabla... */
	    break;    

        default: 
        break;
    }
}

void sdl_main_loop ()
{
  int done = 0;
  SDL_Event event;
  Uint8 *keys;
  
  while (!done) 
  {
     while( SDL_PollEvent(& event) )
        {
            switch ( event.type )
            {
                case SDL_QUIT :  
                    done = 1;
                    break;

                case SDL_KEYDOWN : 
                    sdl_ui_handle_keypressed( & event. key.keysym );
                    break;

                case SDL_MOUSEBUTTONDOWN :
		    /* blabla... */
                    break;

                default: 
                    break;
            } 
        } 

    keys = SDL_GetKeyState(NULL);
    if (keys[SDLK_LEFT] == SDL_PRESSED)
      cam_rotate_terrain_leftright (0.3);  
    if (keys[SDLK_RIGHT] == SDL_PRESSED)
      cam_rotate_terrain_leftright (-0.3); 
    if (keys[SDLK_UP] == SDL_PRESSED)
      cam_move_cam_forwbackw (4);  
    if (keys[SDLK_DOWN] == SDL_PRESSED)
      cam_move_cam_forwbackw (-4);   
      
    sdl_display();
  }

}

void set_up_sdl()
{   

  if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER) < 0)
  {
    fprintf(stderr, "\nFatal Error : %s\n", SDL_GetError());
    exit(0);
  }

  SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
  SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16); 
  SDL_SetVideoMode(800, 600, 16, SDL_OPENGL | SDL_GL_DOUBLEBUFFER);
  
  SDL_WM_SetCaption("Terrain preview (SDL)", NULL);
    
  gl_generic_init();
  
  /* parametres du terrain */
  terrain->size = 129;
  terrain->algo = TERR_HYPERB;
  fill_default_hyperb_params (&hyp_param);
  terrain->spec_param = (void *) &hyp_param;
  
  ui_generic_generate_new_terrain (terrain);
}

#endif /* USE_SDL */
