/* Fichier "algo_fault.c"
 * Algorithme dit de "la formation de failles",
 * algorithme trs simple mais pas tres joli.
 */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

#include "terrain.h"

/* ======================================================
 * TER_gen_terrain_fault
 *
 * Description: tire une droite au hasard dans le terrain, ce 
 *  qui le separe en deux demi plans. Dans un des demi plans 
 *  on augmente toutes les altitudes de dh, et dans l'autre, on
 *  ne fait rien.
 *  On diminue dh  chaque fois lineairement, de dh0  dh0 / 4.
 * =====================================================
 */
void
TER_gen_terrain_fault (TER_terrain_t * terrain)
{
  int xa, ya, xb, yb, x2, y2;
  float z = 0;
  float sign = 0.0f;
  TER_param_fault_t *param = (TER_param_fault_t *) terrain->spec_param;
  int num_iter = param->num_iter;
  int iter = 0;
  float dh0 = param->dh0, dh = 0.0f, dhn = dh0/4;

  srand (time (NULL));

  for (iter = 0; iter < num_iter; iter++) {

    /* tire au hasard la droite (ab) */
    xa = random_int (terrain->size - 1);
    ya = random_int (terrain->size - 1);

    xb = random_int (terrain->size - 1);
    yb = random_int (terrain->size - 1);

    /* calcule dh */
    dh = dh0 + (float)((float)iter/(float)num_iter)*(dhn - dh0);
    
    for (x2 = 0; x2 < terrain->size; x2++) {
      for (y2 = 0; y2 < terrain->size; y2++) {

        /* le demi plan o l'on se trouve depend du signe du determinant
	      ci dessous */
	sign = ((xb - xa) * (y2 - ya) - (yb - ya) * (x2 - xa));

        /* demi plan o l'on augmente tout */
	if (sign > 0)
	  z = dh;
       
        /* demi plan o l'on fait rien */
        else z=0;
	z += TER_get_heightmap_value (terrain, x2, y2);

	if (z > terrain->max_height)
	  terrain->max_height = z;

	TER_set_heightmap_value (terrain, x2, y2, z);
      }
    }
  }
  
  /* on rabaisse le terrain  une altitude correcte en faisant une translation
     (il a tendance  monter un peu trop) */
  TER_FIL_translate_down (terrain);
  printf ("FAULT: max_height=%f\n", terrain->max_height);

}
