#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "terrain.h"

float
TER_get_heightmap_value (TER_terrain_t * terrain, int i, int j)
{
  if (i < 0 || i >= terrain->size || j < 0 || j >= terrain->size) {
    fprintf (stderr, "Warning: out of range in get_heightmap_value (request:(%d,%d)\n",
    i,j);
    return 0;
  }
  else
    return (terrain->heightmap[(j * terrain->size) + i]);
}

void
TER_set_heightmap_value (TER_terrain_t * terrain, int i, int j, float value)
{
  if (i < 0 || i >= terrain->size || j < 0 || j >= terrain->size) {
    fprintf (stderr, "Warning: out of range in set_heightmap_value (request:(%d,%d)\n",
    i,j);
  }
  else
    terrain->heightmap[(j * terrain->size) + i] = value;
}

void
TER_reset_filters (TER_terrain_t * terrain)
{
  int i=FILTER1;
  
  for (i=0; i < NUM_EFFECTIVE_FILTERS; i++)  {
    terrain->filters[i].name = TERR_FILTER_NOTHING;
    terrain->filters[i].param = 0.0f;
  }
}

void
TER_update_maxheight_value (TER_terrain_t *terrain)
{
  int i=0, j=0;
  float z=0;
  
  for (i = 0; i < terrain->size; i++) {
    for (j = 0; j < terrain->size; j++) {
      z = TER_get_heightmap_value (terrain, i, j);
      if (z > terrain->max_height)
        terrain->max_height = z;
    }
  }
}

void
TER_copy_orig_terr_to_effective (TER_terrain_t *terrain)
{
  int i=0;
  for (i=0; i < terrain->size * terrain->size; i++) {
    terrain->heightmap[i] = terrain->heightmap_orig[i];  
  }
}

void
TER_copy_effective_terr_to_orig (TER_terrain_t *terrain)
{
  int i=0;
  for (i=0; i < terrain->size * terrain->size; i++) {
    terrain->heightmap_orig[i] = terrain->heightmap[i];  
  }
}
