#ifndef __TERRAIN_H__
#define __TERRAIN_H__

#define DEFAULT_TERR_ALGO TERR_FLAT
#define DEFAULT_TERR_COLOR TERR_COLOR_SUMMER
#define DEFAULT_TERR_SIZE 129

enum 
{
  FILTER1,
  FILTER2,
  FILTER3,
  FILTER4,
  FILTER5,
  
  NUM_EFFECTIVE_FILTERS 
};

typedef struct TER_filter_t
{
  int name;
  float param;
} TER_filter_t;

typedef struct TER_terrain_t
{
  int size; /* terrain de dimensions size x size */ 
 
  float *heightmap_orig; /* heightmap originale generee */
  float *heightmap; /* hightmap actuelle, i.e. deformee par les filtres */
  float max_height; /* hauteur maximale generee */
  
  unsigned int displaylist; /* displaylist OpenGL eventuelle */
  void *spec_param; /* parametres specifiques */
  
  int algo;
  TER_filter_t filters[NUM_EFFECTIVE_FILTERS];
  int color_scheme;
  
  int generated;
  
} TER_terrain_t;

#include "filters.h"
#include "algos.h"
#include "common.h"

char TER_create_new_terrain (TER_terrain_t ** terrain);
char TER_init_heightmap (TER_terrain_t * terrain);
char TER_init_terrain(TER_terrain_t *terrain);
char TER_gen_terrain(TER_terrain_t *terrain);
char TER_apply_filter (TER_terrain_t * terrain, int filter, float param);

int TER_import_terrain (TER_terrain_t * terrain, void *param, char *filename);
int TER_export_terrain (TER_terrain_t * terrain, char *filename);
int TER_read_algo (char *filename);

char TER_terr_import_raw(TER_terrain_t *terrain, char * filename);
int TER_export_png_bw (TER_terrain_t *terrain, char *filename);

#ifdef USE_BMP_EXPORT
int TER_export_bmp_bw (TER_terrain_t *terrain, char *filename);
#endif /* USE_BMP_EXPORT */

#endif /* __TERRAIN_H__ */
